import React from "react";
import PropTypes from "prop-types";
import "../../style/generic/DisplayError.scss";

function DisplayError(props) {
	let message="";
	if(props.hasOwnProperty("axios")){
		message=<div className="errorTitle">Status {props.axios.response.status} ({props.axios.response.statusText})</div>;
		if(typeof(props.axios.response.data)==="object" && props.axios.response.data.hasOwnProperty("message")){
			message=<React.Fragment>{message}<div className="errorMessage">{props.axios.response.data.message}</div></React.Fragment>;
		}
	}
	return (
		<div className="displayError">{message}</div>
	);
}
DisplayError.propTypes = {
	axios: PropTypes.object
};

export default DisplayError;