import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import { inspectTask } from '../../action/TaskAction';
import TaskList from './TaskList';
import TaskForm from './TaskForm';
import Modal from '../generic/Modal';
import TaskCreate from './TaskCreate';

class TaskIndex extends Component {
	static propTypes = {
		inspectTask: PropTypes.func.isRequired
	}
	closeInspected=()=>{
		this.props.inspectTask("");
	}
	render() {
		let taskInspectedShow=this.props.taskInspected ? true:false;
		return (
			<div>
				<TaskCreate/>
				<TaskList/>
				<Modal show={taskInspectedShow} title="Update" onClose={this.closeInspected}>
					<TaskForm task={this.props.taskInspected} name="inspected"/>
				</Modal>
			</div>
		)
	}
}

const mapStateToProps = (state) => ({
	taskInspected: state.task.tasks.filter(t=>t._id===state.task.taskInspected)[0]
});

export default connect(mapStateToProps, {inspectTask})(TaskIndex);