import { ADD, GET, GET_ALL, UPDATE, DELETE, INSPECT } from '../action/TaskType';

const initialState={
	tasks:[],
	taskInspected: ""
}

export default function taskReducer(state=initialState, action){
	let response;
	switch (action.type) {
		case GET_ALL:
			response={
				...state,
				tasks: action.payload
			};
			break;
		case GET:
			response={
				...state,
				task: action.payload
			};
			break;
		case ADD:
			response={
				...state,
				tasks: [action.payload, ...state.tasks]
			};
			break;
		case UPDATE:
			response={
				...state,
				tasks: [action.payload, ...state.tasks.filter(task=>task._id !== action.payload._id)]
			};
			break;
		case DELETE:
			response={
				...state,
				tasks: state.tasks.filter(task=>task._id !== action.payload)
			};
			break;
		case INSPECT:
			response={
				...state,
				taskInspected: action.payload
			}
			break;
		default:
			response=state;
			break;
	}
	return response;
}