# Kanban

## Description

Proof of concept of a kanban style application.

### Technology stack

+ [MongoDB](https://www.mongodb.com/) for the database with [Mongoose](https://mongoosejs.com/) as the Object Data Manager.
+ [ExpressJS](https://expressjs.com/) as the backend web framework.
+ [React](https://reactjs.org/) for the frontend with [Redux](https://redux.js.org/) to handle the application states.
+ [NodeJS](https://nodejs.org) as the JavaScript runtime.

## Installation

### Using docker

Use the provided `docker-compose.yml` script to launch the application directly.

While being at the root of the application, use:

```bash
docker-compose up
```

### Using npm

If you prefer launching the application directly, you will need to provide a MongoDB instance for the application to connect.
Edit `back/config/keys` with the necessary information.

You can then launch both the back and frontend with ```npm start``` at the root of the application.

## Usage

Navigate to [127.0.0.1:3000](http://127.0.0.1:3000) to see the frontend.

Backend accessible via [127.0.0.1:3001](http://127.0.0.1:3001) (obviously not much to see here)

## Screenshots

**Main screen populated**
![main](assets/main.png)

**Task update screen**
![update](assets/update.png)
